Skip to main content

Dynamic Programming - Medium Level - Question 1

Dynamic Programming - Medium Level - Question 1


Leetcode 91 Decode ways

A message containing letters from A-Z can be encoded into numbers using the following mapping:

'A' -> "1"

'B' -> "2"

...

'Z' -> "26"

To decode an encoded message, all the digits must be grouped then mapped back into letters using the reverse of the mapping above (there may be multiple ways). For example, "11106" can be mapped into:

"AAJF" with the grouping (1 1 10 6)

"KJF" with the grouping (11 10 6)

Note that the grouping (1 11 06) is invalid because "06" cannot be mapped into 'F' since "6" is different from "06".

Given a string s containing only digits, return the number of ways to decode it.

The answer is guaranteed to fit in a 32-bit integer.

Constraints:

1 <= s.length <= 100

s contains only digits and may contain leading zero(s).


Analysis:

We can define f(i) as the number of ways to decode the string to the ith position.

Similar to Climbing Stairs, f(i) can be derived from f(i-1) and f(i-2). (or for each char, we at most just need to consider the previous char).

case 1. If s[i] itself is a valid choice, such as '1', '2', ... '9'; then one way to decode the string to the ith position is decoding the s[0, i-1] and the ith, and the number of ways to decode in this way is f(i-1). 

case 2. If s[i] can be connected with the previous char, then we can decode the string to the ith position as s[0, i-2] + s[i-1, i], and the number of ways to decode in this way is f(i-2).

For each char, 

if only 1 valid, then f(i) = f(i-1); 

else if only 2 valid, then f(i) = f(i-2);

else if both valid, then f(i) = f(i-1) + f(i-2)

else return 0. 

So now the question becomes how to categorize the question based on the value of s[i].  

At each position i, we have 10 possibilities, s[i] could be 0, 1, 2, ..., 9, which gives the range of discussion.

If the first char is '0', then there is no way to decode, game over;

In general, if s[i] == '0', then the s[i-1] has to be '1' or '2' (otherwise, there is no way to decode), and it has to connect with the previous char (since itself cannot be decoded), which is case 2; 

If s[i-1] == '0' or s[i-1] > '2', then s[i-1] cannot be connected with s[i], which is case 1;

If s[i-1] == '2' or s[i] > '6', then s[i-1] cannot be connected with s[i] neither, which is case 1;

For all the rest case,  both 1 and 2 ways are valid, so f[i] = f[i-1] + f[i-2].


See the code below:


class Solution {
public:
    int numDecodings(string s) {
        if(!s.size() || s[0] == '0') return 0;
        int n = s.size();
        vector<int> dp(n+1, 0);
        dp[0] = dp[1] = 1;
        for(int i=2; i<=n; ++i) {
            int cur = s[i-1] - '0', pre = s[i-2] - '0';
            // case 2
            if(cur == 0) dp[i] = (pre == 0 || pre > 2) ? 0 : dp[i-2];
            // case 1
            else if(pre > 2 || pre == 0 || cur > 6 && pre == 2) dp[i] = dp[i-1];
            // case 1 + 2
            else dp[i] = dp[i-1] + dp[i-2];
        }
        return dp[n];
    }
};


Since we just need the last two elements of the dp array, the space can be reduced to constant.

See the code below,

class Solution {
public:
    int numDecodings(string s) {
        if(!s.size() || s[0] == '0') return 0;
        int n = s.size();
        int a = 1, b = 1, c = 1;
        for(int i=1; i<n; ++i) {
            int cur = s[i] - '0', pre = s[i-1] - '0';
            if(cur == 0) c = (pre == 0 || pre > 2) ? 0 : a;
            else if(pre > 2 || pre == 0 || cur > 6 && pre == 2) c = b;
            else c = a + b;
            a = b;
            b = c;
        }
        return c;
    }
};



Upper Layer


Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...